//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: akash/escrow/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service
///
/// Usage: instantiate `Akash_Escrow_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Akash_Escrow_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Akash_Escrow_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func accounts(
    _ request: Akash_Escrow_V1beta1_QueryAccountsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Akash_Escrow_V1beta1_QueryAccountsRequest, Akash_Escrow_V1beta1_QueryAccountsResponse>

  func payments(
    _ request: Akash_Escrow_V1beta1_QueryPaymentsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Akash_Escrow_V1beta1_QueryPaymentsRequest, Akash_Escrow_V1beta1_QueryPaymentsResponse>
}

extension Akash_Escrow_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "akash.escrow.v1beta1.Query"
  }

  /// buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
  /// buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
  /// Accounts queries all accounts
  ///
  /// - Parameters:
  ///   - request: Request to send to Accounts.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func accounts(
    _ request: Akash_Escrow_V1beta1_QueryAccountsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Akash_Escrow_V1beta1_QueryAccountsRequest, Akash_Escrow_V1beta1_QueryAccountsResponse> {
    return self.makeUnaryCall(
      path: "/akash.escrow.v1beta1.Query/Accounts",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAccountsInterceptors() ?? []
    )
  }

  /// buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
  /// buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
  /// Payments queries all payments
  ///
  /// - Parameters:
  ///   - request: Request to send to Payments.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func payments(
    _ request: Akash_Escrow_V1beta1_QueryPaymentsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Akash_Escrow_V1beta1_QueryPaymentsRequest, Akash_Escrow_V1beta1_QueryPaymentsResponse> {
    return self.makeUnaryCall(
      path: "/akash.escrow.v1beta1.Query/Payments",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makePaymentsInterceptors() ?? []
    )
  }
}

internal protocol Akash_Escrow_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'accounts'.
  func makeAccountsInterceptors() -> [ClientInterceptor<Akash_Escrow_V1beta1_QueryAccountsRequest, Akash_Escrow_V1beta1_QueryAccountsResponse>]

  /// - Returns: Interceptors to use when invoking 'payments'.
  func makePaymentsInterceptors() -> [ClientInterceptor<Akash_Escrow_V1beta1_QueryPaymentsRequest, Akash_Escrow_V1beta1_QueryPaymentsResponse>]
}

internal final class Akash_Escrow_V1beta1_QueryClient: Akash_Escrow_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Akash_Escrow_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the akash.escrow.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Akash_Escrow_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Akash_Escrow_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Akash_Escrow_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
  /// buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
  /// Accounts queries all accounts
  func accounts(request: Akash_Escrow_V1beta1_QueryAccountsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Akash_Escrow_V1beta1_QueryAccountsResponse>

  /// buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
  /// buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
  /// Payments queries all payments
  func payments(request: Akash_Escrow_V1beta1_QueryPaymentsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Akash_Escrow_V1beta1_QueryPaymentsResponse>
}

extension Akash_Escrow_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "akash.escrow.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Accounts":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Akash_Escrow_V1beta1_QueryAccountsRequest>(),
        responseSerializer: ProtobufSerializer<Akash_Escrow_V1beta1_QueryAccountsResponse>(),
        interceptors: self.interceptors?.makeAccountsInterceptors() ?? [],
        userFunction: self.accounts(request:context:)
      )

    case "Payments":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Akash_Escrow_V1beta1_QueryPaymentsRequest>(),
        responseSerializer: ProtobufSerializer<Akash_Escrow_V1beta1_QueryPaymentsResponse>(),
        interceptors: self.interceptors?.makePaymentsInterceptors() ?? [],
        userFunction: self.payments(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Akash_Escrow_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'accounts'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAccountsInterceptors() -> [ServerInterceptor<Akash_Escrow_V1beta1_QueryAccountsRequest, Akash_Escrow_V1beta1_QueryAccountsResponse>]

  /// - Returns: Interceptors to use when handling 'payments'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makePaymentsInterceptors() -> [ServerInterceptor<Akash_Escrow_V1beta1_QueryPaymentsRequest, Akash_Escrow_V1beta1_QueryPaymentsResponse>]
}
