//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: akash/provider/v1beta1/provider.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the provider Msg service
///
/// Usage: instantiate `Akash_Provider_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Akash_Provider_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Akash_Provider_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func createProvider(
    _ request: Akash_Provider_V1beta1_MsgCreateProvider,
    callOptions: CallOptions?
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgCreateProvider, Akash_Provider_V1beta1_MsgCreateProviderResponse>

  func updateProvider(
    _ request: Akash_Provider_V1beta1_MsgUpdateProvider,
    callOptions: CallOptions?
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgUpdateProvider, Akash_Provider_V1beta1_MsgUpdateProviderResponse>

  func deleteProvider(
    _ request: Akash_Provider_V1beta1_MsgDeleteProvider,
    callOptions: CallOptions?
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgDeleteProvider, Akash_Provider_V1beta1_MsgDeleteProviderResponse>
}

extension Akash_Provider_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "akash.provider.v1beta1.Msg"
  }

  /// CreateProvider defines a method that creates a provider given the proper inputs
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateProvider.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createProvider(
    _ request: Akash_Provider_V1beta1_MsgCreateProvider,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgCreateProvider, Akash_Provider_V1beta1_MsgCreateProviderResponse> {
    return self.makeUnaryCall(
      path: "/akash.provider.v1beta1.Msg/CreateProvider",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateProviderInterceptors() ?? []
    )
  }

  /// UpdateProvider defines a method that updates a provider given the proper inputs
  ///
  /// - Parameters:
  ///   - request: Request to send to UpdateProvider.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func updateProvider(
    _ request: Akash_Provider_V1beta1_MsgUpdateProvider,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgUpdateProvider, Akash_Provider_V1beta1_MsgUpdateProviderResponse> {
    return self.makeUnaryCall(
      path: "/akash.provider.v1beta1.Msg/UpdateProvider",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUpdateProviderInterceptors() ?? []
    )
  }

  /// DeleteProvider defines a method that deletes a provider given the proper inputs
  ///
  /// - Parameters:
  ///   - request: Request to send to DeleteProvider.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func deleteProvider(
    _ request: Akash_Provider_V1beta1_MsgDeleteProvider,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Akash_Provider_V1beta1_MsgDeleteProvider, Akash_Provider_V1beta1_MsgDeleteProviderResponse> {
    return self.makeUnaryCall(
      path: "/akash.provider.v1beta1.Msg/DeleteProvider",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDeleteProviderInterceptors() ?? []
    )
  }
}

internal protocol Akash_Provider_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'createProvider'.
  func makeCreateProviderInterceptors() -> [ClientInterceptor<Akash_Provider_V1beta1_MsgCreateProvider, Akash_Provider_V1beta1_MsgCreateProviderResponse>]

  /// - Returns: Interceptors to use when invoking 'updateProvider'.
  func makeUpdateProviderInterceptors() -> [ClientInterceptor<Akash_Provider_V1beta1_MsgUpdateProvider, Akash_Provider_V1beta1_MsgUpdateProviderResponse>]

  /// - Returns: Interceptors to use when invoking 'deleteProvider'.
  func makeDeleteProviderInterceptors() -> [ClientInterceptor<Akash_Provider_V1beta1_MsgDeleteProvider, Akash_Provider_V1beta1_MsgDeleteProviderResponse>]
}

internal final class Akash_Provider_V1beta1_MsgClient: Akash_Provider_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Akash_Provider_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the akash.provider.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Akash_Provider_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the provider Msg service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Akash_Provider_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Akash_Provider_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// CreateProvider defines a method that creates a provider given the proper inputs
  func createProvider(request: Akash_Provider_V1beta1_MsgCreateProvider, context: StatusOnlyCallContext) -> EventLoopFuture<Akash_Provider_V1beta1_MsgCreateProviderResponse>

  /// UpdateProvider defines a method that updates a provider given the proper inputs
  func updateProvider(request: Akash_Provider_V1beta1_MsgUpdateProvider, context: StatusOnlyCallContext) -> EventLoopFuture<Akash_Provider_V1beta1_MsgUpdateProviderResponse>

  /// DeleteProvider defines a method that deletes a provider given the proper inputs
  func deleteProvider(request: Akash_Provider_V1beta1_MsgDeleteProvider, context: StatusOnlyCallContext) -> EventLoopFuture<Akash_Provider_V1beta1_MsgDeleteProviderResponse>
}

extension Akash_Provider_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "akash.provider.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "CreateProvider":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Akash_Provider_V1beta1_MsgCreateProvider>(),
        responseSerializer: ProtobufSerializer<Akash_Provider_V1beta1_MsgCreateProviderResponse>(),
        interceptors: self.interceptors?.makeCreateProviderInterceptors() ?? [],
        userFunction: self.createProvider(request:context:)
      )

    case "UpdateProvider":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Akash_Provider_V1beta1_MsgUpdateProvider>(),
        responseSerializer: ProtobufSerializer<Akash_Provider_V1beta1_MsgUpdateProviderResponse>(),
        interceptors: self.interceptors?.makeUpdateProviderInterceptors() ?? [],
        userFunction: self.updateProvider(request:context:)
      )

    case "DeleteProvider":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Akash_Provider_V1beta1_MsgDeleteProvider>(),
        responseSerializer: ProtobufSerializer<Akash_Provider_V1beta1_MsgDeleteProviderResponse>(),
        interceptors: self.interceptors?.makeDeleteProviderInterceptors() ?? [],
        userFunction: self.deleteProvider(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Akash_Provider_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'createProvider'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateProviderInterceptors() -> [ServerInterceptor<Akash_Provider_V1beta1_MsgCreateProvider, Akash_Provider_V1beta1_MsgCreateProviderResponse>]

  /// - Returns: Interceptors to use when handling 'updateProvider'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUpdateProviderInterceptors() -> [ServerInterceptor<Akash_Provider_V1beta1_MsgUpdateProvider, Akash_Provider_V1beta1_MsgUpdateProviderResponse>]

  /// - Returns: Interceptors to use when handling 'deleteProvider'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDeleteProviderInterceptors() -> [ServerInterceptor<Akash_Provider_V1beta1_MsgDeleteProvider, Akash_Provider_V1beta1_MsgDeleteProviderResponse>]
}
