//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: oracle/v1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the oracle Msg service.
///
/// Usage: instantiate `Oracle_V1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Oracle_V1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Oracle_V1_MsgClientInterceptorFactoryProtocol? { get }

  func requestData(
    _ request: Oracle_V1_MsgRequestData,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgRequestData, Oracle_V1_MsgRequestDataResponse>

  func reportData(
    _ request: Oracle_V1_MsgReportData,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgReportData, Oracle_V1_MsgReportDataResponse>

  func createDataSource(
    _ request: Oracle_V1_MsgCreateDataSource,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgCreateDataSource, Oracle_V1_MsgCreateDataSourceResponse>

  func editDataSource(
    _ request: Oracle_V1_MsgEditDataSource,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgEditDataSource, Oracle_V1_MsgEditDataSourceResponse>

  func createOracleScript(
    _ request: Oracle_V1_MsgCreateOracleScript,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgCreateOracleScript, Oracle_V1_MsgCreateOracleScriptResponse>

  func editOracleScript(
    _ request: Oracle_V1_MsgEditOracleScript,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgEditOracleScript, Oracle_V1_MsgEditOracleScriptResponse>

  func activate(
    _ request: Oracle_V1_MsgActivate,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgActivate, Oracle_V1_MsgActivateResponse>

  func addReporter(
    _ request: Oracle_V1_MsgAddReporter,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgAddReporter, Oracle_V1_MsgAddReporterResponse>

  func removeReporter(
    _ request: Oracle_V1_MsgRemoveReporter,
    callOptions: CallOptions?
  ) -> UnaryCall<Oracle_V1_MsgRemoveReporter, Oracle_V1_MsgRemoveReporterResponse>
}

extension Oracle_V1_MsgClientProtocol {
  internal var serviceName: String {
    return "oracle.v1.Msg"
  }

  /// RequestData defines a method for submitting a new request.
  ///
  /// - Parameters:
  ///   - request: Request to send to RequestData.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func requestData(
    _ request: Oracle_V1_MsgRequestData,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgRequestData, Oracle_V1_MsgRequestDataResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/RequestData",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRequestDataInterceptors() ?? []
    )
  }

  /// ReportData defines a method for reporting a data to resolve the request.
  ///
  /// - Parameters:
  ///   - request: Request to send to ReportData.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func reportData(
    _ request: Oracle_V1_MsgReportData,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgReportData, Oracle_V1_MsgReportDataResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/ReportData",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeReportDataInterceptors() ?? []
    )
  }

  /// CreateDataSource defines a method for creating a new data source.
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateDataSource.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createDataSource(
    _ request: Oracle_V1_MsgCreateDataSource,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgCreateDataSource, Oracle_V1_MsgCreateDataSourceResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/CreateDataSource",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateDataSourceInterceptors() ?? []
    )
  }

  /// EditDataSource defines a method for editing an existing data source.
  ///
  /// - Parameters:
  ///   - request: Request to send to EditDataSource.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func editDataSource(
    _ request: Oracle_V1_MsgEditDataSource,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgEditDataSource, Oracle_V1_MsgEditDataSourceResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/EditDataSource",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEditDataSourceInterceptors() ?? []
    )
  }

  /// CreateOracleScript defines a method for creating a new oracle script.
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateOracleScript.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createOracleScript(
    _ request: Oracle_V1_MsgCreateOracleScript,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgCreateOracleScript, Oracle_V1_MsgCreateOracleScriptResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/CreateOracleScript",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateOracleScriptInterceptors() ?? []
    )
  }

  /// EditOracleScript defines a method for editing an existing oracle script.
  ///
  /// - Parameters:
  ///   - request: Request to send to EditOracleScript.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func editOracleScript(
    _ request: Oracle_V1_MsgEditOracleScript,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgEditOracleScript, Oracle_V1_MsgEditOracleScriptResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/EditOracleScript",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEditOracleScriptInterceptors() ?? []
    )
  }

  /// Activate defines a method for applying to be an oracle validator.
  ///
  /// - Parameters:
  ///   - request: Request to send to Activate.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func activate(
    _ request: Oracle_V1_MsgActivate,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgActivate, Oracle_V1_MsgActivateResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/Activate",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeActivateInterceptors() ?? []
    )
  }

  /// AddReporter defines a method for adding a new reporter for a validator.
  ///
  /// - Parameters:
  ///   - request: Request to send to AddReporter.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func addReporter(
    _ request: Oracle_V1_MsgAddReporter,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgAddReporter, Oracle_V1_MsgAddReporterResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/AddReporter",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAddReporterInterceptors() ?? []
    )
  }

  /// RemoveReporter defines a method for removing an reporter from a validator
  ///
  /// - Parameters:
  ///   - request: Request to send to RemoveReporter.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func removeReporter(
    _ request: Oracle_V1_MsgRemoveReporter,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Oracle_V1_MsgRemoveReporter, Oracle_V1_MsgRemoveReporterResponse> {
    return self.makeUnaryCall(
      path: "/oracle.v1.Msg/RemoveReporter",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRemoveReporterInterceptors() ?? []
    )
  }
}

internal protocol Oracle_V1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'requestData'.
  func makeRequestDataInterceptors() -> [ClientInterceptor<Oracle_V1_MsgRequestData, Oracle_V1_MsgRequestDataResponse>]

  /// - Returns: Interceptors to use when invoking 'reportData'.
  func makeReportDataInterceptors() -> [ClientInterceptor<Oracle_V1_MsgReportData, Oracle_V1_MsgReportDataResponse>]

  /// - Returns: Interceptors to use when invoking 'createDataSource'.
  func makeCreateDataSourceInterceptors() -> [ClientInterceptor<Oracle_V1_MsgCreateDataSource, Oracle_V1_MsgCreateDataSourceResponse>]

  /// - Returns: Interceptors to use when invoking 'editDataSource'.
  func makeEditDataSourceInterceptors() -> [ClientInterceptor<Oracle_V1_MsgEditDataSource, Oracle_V1_MsgEditDataSourceResponse>]

  /// - Returns: Interceptors to use when invoking 'createOracleScript'.
  func makeCreateOracleScriptInterceptors() -> [ClientInterceptor<Oracle_V1_MsgCreateOracleScript, Oracle_V1_MsgCreateOracleScriptResponse>]

  /// - Returns: Interceptors to use when invoking 'editOracleScript'.
  func makeEditOracleScriptInterceptors() -> [ClientInterceptor<Oracle_V1_MsgEditOracleScript, Oracle_V1_MsgEditOracleScriptResponse>]

  /// - Returns: Interceptors to use when invoking 'activate'.
  func makeActivateInterceptors() -> [ClientInterceptor<Oracle_V1_MsgActivate, Oracle_V1_MsgActivateResponse>]

  /// - Returns: Interceptors to use when invoking 'addReporter'.
  func makeAddReporterInterceptors() -> [ClientInterceptor<Oracle_V1_MsgAddReporter, Oracle_V1_MsgAddReporterResponse>]

  /// - Returns: Interceptors to use when invoking 'removeReporter'.
  func makeRemoveReporterInterceptors() -> [ClientInterceptor<Oracle_V1_MsgRemoveReporter, Oracle_V1_MsgRemoveReporterResponse>]
}

internal final class Oracle_V1_MsgClient: Oracle_V1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Oracle_V1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the oracle.v1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Oracle_V1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the oracle Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Oracle_V1_MsgProvider: CallHandlerProvider {
  var interceptors: Oracle_V1_MsgServerInterceptorFactoryProtocol? { get }

  /// RequestData defines a method for submitting a new request.
  func requestData(request: Oracle_V1_MsgRequestData, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgRequestDataResponse>

  /// ReportData defines a method for reporting a data to resolve the request.
  func reportData(request: Oracle_V1_MsgReportData, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgReportDataResponse>

  /// CreateDataSource defines a method for creating a new data source.
  func createDataSource(request: Oracle_V1_MsgCreateDataSource, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgCreateDataSourceResponse>

  /// EditDataSource defines a method for editing an existing data source.
  func editDataSource(request: Oracle_V1_MsgEditDataSource, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgEditDataSourceResponse>

  /// CreateOracleScript defines a method for creating a new oracle script.
  func createOracleScript(request: Oracle_V1_MsgCreateOracleScript, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgCreateOracleScriptResponse>

  /// EditOracleScript defines a method for editing an existing oracle script.
  func editOracleScript(request: Oracle_V1_MsgEditOracleScript, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgEditOracleScriptResponse>

  /// Activate defines a method for applying to be an oracle validator.
  func activate(request: Oracle_V1_MsgActivate, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgActivateResponse>

  /// AddReporter defines a method for adding a new reporter for a validator.
  func addReporter(request: Oracle_V1_MsgAddReporter, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgAddReporterResponse>

  /// RemoveReporter defines a method for removing an reporter from a validator
  func removeReporter(request: Oracle_V1_MsgRemoveReporter, context: StatusOnlyCallContext) -> EventLoopFuture<Oracle_V1_MsgRemoveReporterResponse>
}

extension Oracle_V1_MsgProvider {
  internal var serviceName: Substring { return "oracle.v1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "RequestData":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgRequestData>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgRequestDataResponse>(),
        interceptors: self.interceptors?.makeRequestDataInterceptors() ?? [],
        userFunction: self.requestData(request:context:)
      )

    case "ReportData":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgReportData>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgReportDataResponse>(),
        interceptors: self.interceptors?.makeReportDataInterceptors() ?? [],
        userFunction: self.reportData(request:context:)
      )

    case "CreateDataSource":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgCreateDataSource>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgCreateDataSourceResponse>(),
        interceptors: self.interceptors?.makeCreateDataSourceInterceptors() ?? [],
        userFunction: self.createDataSource(request:context:)
      )

    case "EditDataSource":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgEditDataSource>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgEditDataSourceResponse>(),
        interceptors: self.interceptors?.makeEditDataSourceInterceptors() ?? [],
        userFunction: self.editDataSource(request:context:)
      )

    case "CreateOracleScript":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgCreateOracleScript>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgCreateOracleScriptResponse>(),
        interceptors: self.interceptors?.makeCreateOracleScriptInterceptors() ?? [],
        userFunction: self.createOracleScript(request:context:)
      )

    case "EditOracleScript":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgEditOracleScript>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgEditOracleScriptResponse>(),
        interceptors: self.interceptors?.makeEditOracleScriptInterceptors() ?? [],
        userFunction: self.editOracleScript(request:context:)
      )

    case "Activate":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgActivate>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgActivateResponse>(),
        interceptors: self.interceptors?.makeActivateInterceptors() ?? [],
        userFunction: self.activate(request:context:)
      )

    case "AddReporter":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgAddReporter>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgAddReporterResponse>(),
        interceptors: self.interceptors?.makeAddReporterInterceptors() ?? [],
        userFunction: self.addReporter(request:context:)
      )

    case "RemoveReporter":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Oracle_V1_MsgRemoveReporter>(),
        responseSerializer: ProtobufSerializer<Oracle_V1_MsgRemoveReporterResponse>(),
        interceptors: self.interceptors?.makeRemoveReporterInterceptors() ?? [],
        userFunction: self.removeReporter(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Oracle_V1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'requestData'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRequestDataInterceptors() -> [ServerInterceptor<Oracle_V1_MsgRequestData, Oracle_V1_MsgRequestDataResponse>]

  /// - Returns: Interceptors to use when handling 'reportData'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeReportDataInterceptors() -> [ServerInterceptor<Oracle_V1_MsgReportData, Oracle_V1_MsgReportDataResponse>]

  /// - Returns: Interceptors to use when handling 'createDataSource'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateDataSourceInterceptors() -> [ServerInterceptor<Oracle_V1_MsgCreateDataSource, Oracle_V1_MsgCreateDataSourceResponse>]

  /// - Returns: Interceptors to use when handling 'editDataSource'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEditDataSourceInterceptors() -> [ServerInterceptor<Oracle_V1_MsgEditDataSource, Oracle_V1_MsgEditDataSourceResponse>]

  /// - Returns: Interceptors to use when handling 'createOracleScript'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateOracleScriptInterceptors() -> [ServerInterceptor<Oracle_V1_MsgCreateOracleScript, Oracle_V1_MsgCreateOracleScriptResponse>]

  /// - Returns: Interceptors to use when handling 'editOracleScript'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEditOracleScriptInterceptors() -> [ServerInterceptor<Oracle_V1_MsgEditOracleScript, Oracle_V1_MsgEditOracleScriptResponse>]

  /// - Returns: Interceptors to use when handling 'activate'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeActivateInterceptors() -> [ServerInterceptor<Oracle_V1_MsgActivate, Oracle_V1_MsgActivateResponse>]

  /// - Returns: Interceptors to use when handling 'addReporter'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAddReporterInterceptors() -> [ServerInterceptor<Oracle_V1_MsgAddReporter, Oracle_V1_MsgAddReporterResponse>]

  /// - Returns: Interceptors to use when handling 'removeReporter'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRemoveReporterInterceptors() -> [ServerInterceptor<Oracle_V1_MsgRemoveReporter, Oracle_V1_MsgRemoveReporterResponse>]
}
